# Rectangle<T extends num> class

A class for representing two-dimensional rectangles whose properties are immutable.

Implementers
  - MutableRectangle

## Constructors

Rectangle(T left, T top, T width, T height)
  Create a rectangle spanned by `(left, top)` and `(left+width, top+height)`. [...]
  const
Rectangle.fromPoints(Point<T> a, Point<T> b)
  Create a rectangle spanned by the points `a` and `b`; [...]
  factory

## Properties

height → T
  The height of the rectangle.
  final
left → T
  The x-coordinate of the left edge.
  final
top → T
  The y-coordinate of the top edge.
  final
width → T
  The width of the rectangle.
  final
bottom → T
  The y-coordinate of the bottom edge.
  read-only, inherited
bottomLeft → Point<T>
  read-only, inherited
bottomRight → Point<T>
  read-only, inherited
hashCode → int
  The hash code for this object. [...]
  read-only, inherited
right → T
  The x-coordinate of the right edge.
  read-only, inherited
runtimeType → Type
  A representation of the runtime type of the object.
  read-only, inherited
topLeft → Point<T>
  read-only, inherited
topRight → Point<T>
  read-only, inherited

## Methods

boundingBox(Rectangle<T> other) → Rectangle<T>
  Returns a new rectangle which completely contains `this` and `other`.
  inherited
containsPoint(Point<num> another) → bool
  Tests whether `another` is inside or along the edges of `this`.
  inherited
containsRectangle(Rectangle<num> another) → bool
  Tests whether `this` entirely contains `another`.
  inherited
intersection(Rectangle<T> other) → Rectangle<T>
  Computes the intersection of `this` and `other`. [...]
  inherited
intersects(Rectangle<num> other) → bool
  Returns true if `this` intersects `other`.
  inherited
noSuchMethod(Invocation invocation) → dynamic
  Invoked when a non-existent method or property is accessed. [...]
  inherited
toString() → String
  Returns a string representation of this object.
  inherited

## Operators

operator ==(dynamic other) → bool
  The equality operator. [...]
  inherited